%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% TP 2 de Data Mining : Petit probleme purement theorique
% Auteur : Maxime Chambreuil - Florian Boitrel
% Date : 12 fevrier 2003

close all
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialisation des variables

nbIndividu = 50;
nbVar = 2;
esperance = [2 1];
matVarCov = ones(2,2);
matVarCov (2,2) = 4;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generation de la matrice dont chaque
% colonne suit une loi normale

echantillon = genererMatNormale(nbIndividu,nbVar,esperance,matVarCov);
x1 = echantillon(:,1);
x2 = echantillon(:,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% On estime les parametres de la loi
% a partir de l'echantillon

% On calcule la moyenne de l'echantillon
moyenne = mean(echantillon,1);

% On l'affiche avec l'esperance
fprintf('\nLa moyenne sur l echantillon est de :\n\n\t%f\t%f\n\n',moyenne(1,1),moyenne(1,2));
fprintf('\nL esperance est de :\n\n\t%f\t%f\n\n',esperance(1,1),esperance(1,2));

% On calcule la matrice de variance-covariance sur l'echantillon
variance = cov(echantillon);

% On l'affiche avec la matrice initiale
fprintf('\nLa matrice de variance-covariance sur l echantillon est :\n\n\t%f\t%f\n\n\t%f\t%f\n\n',variance(1,1),variance(1,2),variance(2,1),variance(2,2));
fprintf('\nLa matrice de variance-covariance est :\n\n\t%f\t%f\n\n\t%f\t%f\n\n',matVarCov(1,1),matVarCov(1,2),matVarCov(2,1),matVarCov(2,2));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% On affiche en 3D a partir des parametres estimes

[Xg,Yg] = meshgrid(-2:0.1:6,-5:0.1:7);
[n,p] = size (Xg);
x = [reshape(Xg,n*p,1) reshape(Yg,n*p,1)];

loiJointe = gauss(x', moyenne',variance);
loiJointe = reshape(loiJointe,n,p);
figure(1);
mesh(loiJointe)
figure(2);
contour(linspace(-2,6,p),linspace(-5,7,n),loiJointe); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% On estime l'esperance conditionnelle
% de x2 sachant x1 = -1

ro = variance(1,2)/(sqrt(variance(1,1))*sqrt(variance(2,2)));
esperanceCondi = moyenne(2)+ro*sqrt(variance(1,1)/variance(2,2))*(-1-moyenne(1))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% On estime la variance conditionnelle
% de x2 sachant x1 = -1

varianceCondi = variance(1,1).^2*(1-ro.^2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% On calcule la loi conditionnelle
% de x2 sachant x1 = -1 en fonction de parametres estimes

vecteur = randn(1000,1);
var1 = 1/((sqrt(2*pi))*varianceCondi);
var2 = ((vecteur-esperanceCondi).^2./(varianceCondi)^2);
loiCondi = var1 * exp(-var2/2);
figure(3);
plot(vecteur,loiCondi,'+');
